\  ttyS.4th
\ -----------------------------------------------------------------------------
\  class ttyS               OOP Module for csp4th                    MM-080211
\ -----------------------------------------------------------------------------
\
\                      Copyright (C) 2008 Manfred Mahlow
\
\ This is Open Source Software released under the "Artistic License". See the
\ enclosed LICENSE file.
\ -----------------------------------------------------------------------------
 
  needs Cell
  needs Short
  needs tty
 
  c api definitions  decimal
 
  $541B constant FIONREAD   \ from /usr/include/asm/ioctls.h 
 
    400 constant O_NOCTTY   \ from /usr/include/asm/fcntl.h
 
  oop definitions  c api
 
  class ttyS  ttyS definitions  tty inherit  self seal

  m: open (O -- )
     this fd @ -1 >if exit then
   \ O_RDWR O_NOCTTY or O_NONBLOCK or this open  ioerr @
     this open/rwn ioerr @
     if (? ."    " this path ? ."  open error " cr ) exit then
     this fd @  dup this \termios @  this termios !
   ;

  m: close (O -- )
           this fd @ dup 0 <if drop exit then  this \termios !
           this close cr ;
 
  self m' open  alias now (S oid -- )

  m: init (O cflags iflags oflags lflags a u fd -- )
      this init               \ initialize the device
      this termios lflags !   \ initialize the terminal flags
      this termios oflags !
      this termios iflags !
      CREAD or this termios cflags !
      this termios cc init
   ;

  Cell new mask       CBAUD self mask init

  m: cflag (S x -- )
     create , self mask @ invert ,
     does> (S oid a -- oid )
           over self termios cflags @ over cell+ @ and swap @ or
           over self termios cflags ! ;
           
        B0 self cflag B0
     B1200 self cflag B1200
     B2400 self cflag B2400
     B4800 self cflag B4800
     B9600 self cflag B9600
    B19200 self cflag B19200
    B38400 self cflag B38400
    B57600 self cflag B57600
   B115200 self cflag B115200
 
  CSIZE CPARITY or CSTOPB or self mask !
 
  CS7 PAREVEN or ONESTOPB or self cflag 7E1
  CS8 PARNONE or ONESTOPB or self cflag 8N1
 
  CRTSCTS self mask !
 
  CRTSCTS self cflag +RTS/CTS
        0 self cflag -RTS/CTS

  CLOCAL self mask !

  CLOCAL self cflag +CLOCAL
       0 self cflag -CLOCAL
 
  hide mask  hide cflag

  oop definitions
\ -----------------------------------------------------------------------------
\ Last revision: MM-080409  stack diagrams
