needs os/console
white bold background black foreground
: norm black foreground ;
: red prior red foreground ;
norm 

cls
." Welcome to the " red .ver  norm ."  installer!" cr
cr cr

(os) [IF]
create procname 255 allot
create proclink 255 allot
85 constant linux_readlink
: has/proc? 
	" /proc/" procname place
	getpid (.) procname +place
	" /exe" procname +place
	procname count open/r dup 0 >if close else 
	." Because of your system's setup, you MUST use the full path to" cr
	." Reva in order for it to work properly" cr
	then ;

has/proc?

	." There is nothing to 'install' on Linux.  You may want to add" cr
	'" emit red appdir type norm '" emit ."  to your $PATH" cr
[ELSE]
needs os/registry
needs string/trim

variable hreg
variable isnt
u32 drop " SendMessageA" 4 func SendMessage
26 constant WM_WININICHANGE

: yesno ekey lc 'y <>if cr ." Bye!" norm cr bye then ;
: installed? 
	HKCU " Software\\Reva" zt hreg RegOpenKey drop
	hreg @ if 
		255 temp !
		hreg @ 0 scratch temp RegQueryValue drop
		hreg @ RegCloseKey drop
		scratch temp @  1-  revaver cmp 0if
			." This version of Reva has already been installed.  Reinstall? "
			yesno cr
		then
	then
	;

installed?
." This will install Reva, making a desktop shortcut and an Explorer association" cr
red ." Do you want to continue?" norm yesno
cr
." Creating appropriate registry entries..." cr

| Are we on NT?
HKLM " SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion" zt hreg RegOpenKey drop
hreg @ isnt !
hreg @ RegCloseKey drop

HKCR " .f" zt hreg RegCreateKey drop
hreg @ 0 REG_SZ " reva_auto_file" RegSetValue drop
hreg @ RegCloseKey drop

appname zcount scratch lplace
"  \"%1\"" scratch +lplace

create scratch2 8000 allot 
HKCR " reva_auto_file\\shell\\open\\command" zt hreg RegCreateKey drop
hreg @ 0 REG_SZ scratch lcount RegSetValue drop
hreg @ RegCloseKey drop

HKCR " Applications\\reva.exe\\shell\\open\\command" zt hreg RegCreateKey drop
hreg @ 0 REG_SZ scratch lcount RegSetValue drop
hreg @ RegCloseKey drop

HKCU " Software\\Reva" zt hreg RegCreateKey drop
hreg @ 0 REG_SZ revaver RegSetValue drop
hreg @ RegCloseKey drop

: setpath
	isnt @ if 
		| WinNT
		HKCU " Environment" zt hreg RegCreateKey drop
		7999 temp !
		hreg @ " path" zt 0 0 scratch2 temp RegQueryValueEx drop
		scratch2 temp @ trim scratch lplace
		" ;" scratch +lplace
		appdir 1- scratch +lplace

		| scratch lcount type cr

		hreg @ " path" zt 0 REG_EXPAND_SZ scratch lcount trim 1+ RegSetValueEx drop
		hreg @ RegCloseKey drop
		| Tell NT we changed the environment:
		-1 WM_WININICHANGE 0 " Environment" zt SendMessage
		." Please start another command-shell so the changes to %PATH% will take effect"
	else
		| Win9x - have to write to the autoexec.bat
		" PATH=%PATH%;" scratch place
		appdir 1- scratch +place
		" c:\\autoexec.bat" open/rw ioerr @ if 
			drop " c:\\autoexec.bat" creat
		then
		| seek to end-of-file
		dup fsize over seek
		dup scratch count rot write close
		." You will need to reboot so the changes to %PATH% will take effect"
	then
	;
setpath
cr

[THEN]

red ." Done installing." norm cr

cr 
." Please read the README file for more details." cr
." When you run Reva, you can get help by just typing " red ." help" norm cr cr
." Enjoy Reva!" cr bye
