
  needs GtkToplevel
  needs GtkLabel
  needs GTimeout
\ ------------------------------------------------------------------------------
\  csp4th OOP                GTimeout example.2                       MM-060901
\ ------------------------------------------------------------------------------
\                    Copyright (C) 2008 Manfred Mahlow
\
\                    This code is in the public domain.
\ ------------------------------------------------------------------------------

  oop definitions  also

  class GtkCPUTemp  GtkCPUTemp definitions   GtkLabel inherit

   private

   GTimeout this timer
   
   self seal

   m: update ( oid -- )
      >r (R -- oid ) 40 dup (buf) dup rot (S -- a a 40 )
      " /proc/acpi/thermal_zone/THRM/temperature" open/r
      ioerr @ 0if
        dup >r read (S -- a u ) r> close 
        ': \char  ': skip  bl skip  bl -chop " °C" bl join
      else
        drop 2drop " _ _ °C"
      then
      r> self text ! ;

   :: ( oid -- true ) self update true \ returning false stops the timer
    ; 1 50 cb cb.timer ( oid -- true ) \ see glib-The-Main-Event-Loop.html

   :: ( wid oid -- ) self timer remove
    ; 2 20 cb cb.destroy

   public

   m: init (S msec oid -- wid )
           (O oid -- ) (S msec -- wid )
      " _ _ °C" this init >r  this use-markup on  6 this xpad !
      this cb.timer this timer init
      " destroy" this cb.destroy swap this signal connect drop r>
    ;

  GTimeout definitions

  private vocabulary example.2  self example.2 definitions

  GtkToplevel new window 
  GtkCPUTemp  new  temp

  :: ( wid 0 -- ) gtk main_quit ;  2 20 cb cb.destroy

  : run ( -- )

        " GTimeout Example 2" window init  1 window border-width !

        1000 temp init window add

        " destroy" cb.destroy 0 window signal connect drop

        window show_all
  
  ;

  hide cb.destroy

  run term? [IF] ?? [ELSE] gtk main bye [THEN]

\ ------------------------------------------------------------------------------
\ Last revision: MM-080803  show all -> show_all , gtk main -> gtk main_quit
