
  needs GtkToplevel
  needs GtkDialog
  needs GtkHBox
  needs GtkImage
  needs GtkLabel
\ ------------------------------------------------------------------------------
\  csp4th :  class GtkDialog Example.1                                MM-061227
\ ------------------------------------------------------------------------------

   GtkDialog definitions

   private vocabulary example.1  self example.1 definitions

   GtkToplevel new window
   GtkDialog   new dialog
   GtkHBox     new  hbox
   GtkImage    new   image
   GtkVBox     new   vbox
   GtkLabel    new    question
   GtkLabel    new    message

   :: ( wid data -- )
      \? cr ." dialog respone signal received "
    ; 2 20 cb cb.response

   :: ( wid event data -- true|false )  \ delete-event handler

      " GtkDialog Example 1" dialog init

      12 dialog vbox border-width !

      window @ dialog transient-parent !  \ dialog destroy-with-parent yes

      dialog resizable no

      hbox init dialog vbox pack_start_defaults

      " gtk-dialog-question" image from-stock dialog-size init
      hbox pack_start_defaults

      vbox init hbox pack_end_defaults

      " <b>Programm beenden?</b>" question init  vbox pack_start_defaults

      question use-markup yes

      " Drücken Sie  \"Abbrechen\" , wenn Sie das Programm nicht beenden wollen."

      message init  vbox pack_end_defaults

      message wrap yes   12 message xpad !  6 message ypad !

      " gtk-cancel" -4 dialog button add

      " gtk-quit" false dialog button add   false dialog default-response !

      " response" cb.response 0 dialog signal connect drop

      dialog run  dialog destroy

   ; 3 40 cb cb.delete


  :: ( wid data -- ) window destroy  gtk main_quit ;  2 20 cb cb.quit

  : run ( -- )

      " GtkDialog Example 1" window init   300 300 window default-size !

      " delete-event" cb.delete 0 window signal connect drop
      " destroy"      cb.quit   0 window signal connect drop

      window show_all

      gtk pending

  ;

  hide cb.response  hide cb.delete  hide cb.quit

  run term? [IF] ?? [ELSE] gtk main bye [THEN]

\ ------------------------------------------------------------------------------
\ Last revision: MM-080803  gtk quit -> gtk main_quit , show all -> show_all
\                           pack defaults start -> pack_start_defaults
\                           pack defaults end -> pack_end_defaults
