#! /usr/local/bin/csp4th

   needs GtkToplevel
   needs GtkVBox
   needs GtkMenuBar
   needs GtkSubMenu
   needs GtkMenu
   needs GtkMenuItem
   needs GtkImageMenuItem

   needs GtkImageFromStock
   needs GtkEventBox
\ ------------------------------------------------------------------------------
\  csp4th OOP                 GtkMenu example.2                       MM-080317
\ ------------------------------------------------------------------------------
\                    Copyright (C) 2008 Manfred Mahlow
\
\                    This code is in the public domain.
\ ------------------------------------------------------------------------------
   gtk api definitions

   libgtk import gtk_accel_group_new ( -- *accel_group )


   GtkMenu definitions

   private vocabulary example.2  self example.2 definitions  also gtk api

   GtkToplevel      new window
   GtkVBox          new  vbox
   GtkMenuBar       new   menu-bar
   GtkSubMenu       new     file-menu
   GtkImageMenuItem new       file-open
   GtkMenuItem      new       file-open...
   GtkImageMenuItem new       file-open...(2)
   GtkImageMenuItem new       file-quit
   GtkImageMenuItem new       file-quit(2)
   GtkSubMenu       new     edit-menu
   GtkImageMenuItem new       edit-pref
   GtkSubMenu       new     help-menu
   GtkImageMenuItem new       help-info
   GtkImageMenuItem new       help-about
   GtkEventBox      new   event-box


   gtk_accel_group_new constant accel


   :: ( wid data -- ) 2drop gtk main_quit ; 2 20 cb 'destroy

   :: ( wid data -- ) window destroy ; 2 20 cb 'Ende

   :: ( wid data -- ) nip cr ." m" . ."  activated " ; 2 20 cb 'activated

   :: ( wid data -- ) 2drop 0 file-menu popup true ; 2 20 cb 'clicked


   : run ( -- )
         " GtkMenu Example 1" window init   300 300 window default-size !

         vbox init window add

         menu-bar init  false false 2 vbox pack_start

         accel window accel-group add

         " _Datei" file-menu init  menu-bar append
              " gtk-open" accel file-open init
              " _Ort öffnen...(1)" file-open... init
              " _Ort öffnen...(2)" 0 file-open...(2) init
              " gtk-open"  pad dup off  GtkImage from-stock menu-size init
              file-open...(2) image !
              " gtk-quit" 0 file-quit init
              " gtk-quit" accel file-quit(2) init
              5 0 do file-menu prepend loop

         " _Bearbeiten" edit-menu init  menu-bar append
              " gtk-preferences" accel edit-pref init  edit-menu append

         " _Hilfe" help-menu init  menu-bar append
              " gtk-help"  accel help-info  init  help-menu append
              " gtk-about" accel help-about init  help-menu append

         " activate" 'activated 1 file-open... signal connect drop
         " activate" 'activated 1 file-open signal connect drop
         " activate" 'activated 2 edit-pref signal connect drop
         " activate" 'Ende      0 file-quit signal connect drop
         " activate" 'Ende      0 file-quit(2) signal connect drop

         event-box init  true true 2 vbox pack_end

         " button-press-event" 'clicked 0 event-box signal connect drop

         " destroy" 'destroy 0 window signal connect drop

         window show_all
    ;


   previous  run term? [IF] ?? [ELSE] gtk main bye [THEN]

\ ------------------------------------------------------------------------------
\ Last revision: MM-080803  gtk quit -> gtk main_quit , show all -> show_all
\                           pack start -> pack_start , pack end -> pack_end









