\ Source Code extracted from TinyTerm.src
\ -----------------------------------------------------------------------------
\  class TinyTerm              OOP Module for csp4th                 MM-080211
\ -----------------------------------------------------------------------------
\
\                       Copyright (C) 2008 Manfred Mahlow
\
\ This is Open Source Software released under the "Artistic License". See the
\ enclosed LICENSE file.
\ -----------------------------------------------------------------------------
  needs oop
  needs ttyS
  needs Cell
 
  oop definitions  c api
 
  class TinyTerm  TinyTerm definitions  ttyS inherit

  Cell this (?rx)
  Cell this (?tx)

   private

   m: io-handler (O -- )
      begin  
        key? if
          stdin rx if 
            dup 27 = if stdin flush drop exit then
            this (?tx) @ execute
          then
        then
        this rx if this (?rx) @ execute then
     again ;

   public

   m: init (O cflags iflags oflags lflags a u fd ?tx ?rx -- )
      this (?rx) init  this (?tx) init  this init ;

   m: open (O -- )
      this ( dev ) open  cr ." Terminal: " this ?
      cr cr
      ." Press [Esc] to close the terminal and return to the Forth Interpreter."
      cr cr 
      stdin fd @ >r
      r@ stdin \termios @
      r@ stdin termios @
      stdin termios lflags @  ECHO ICANON or not and  stdin termios lflags !
      r@  stdin termios !
      this io-handler
      r> stdin \termios !  this close ;

  oop definitions
\ -----------------------------------------------------------------------------
\  Last revision: MM-080531  Reva repeat while -> begin 0until
\                 MM-080409  stack diagrams
