\ -----------------------------------------------------------------------------
\  TinyTerm example.1            OOP Module for csp4th               MM-080211
\ -----------------------------------------------------------------------------
\
\                      Copyright (C) 2008 Manfred Mahlow
\
\ This is Open Source Software released under the "Artistic License". See the
\ enclosed LICENSE file.
\ -----------------------------------------------------------------------------
\ To run this example enter 'needs TinyTerm example.1' on the csp4th command 
\ line or enter csp4th -n "TinyTerm example.1" in an X-Terminal.

  needs TinyTerm

  oop definitions  c api

  TinyTerm new terminal

  B38400 CS8 or PARNONE or ONESTOPB or CREAD or CLOCAL or   \ cflags
\ 0       \ iflags  \ no imput processing
  ICRNL   \ iflags  \ change received CR to NL
\ 0       \ oflags  \ no output processing
  ONLCR OPOST or  \ oflags  \ change outgoing NL to CR+NL
  0       \ lflags
  " /dev/ttyS1" -1
  :: (S b -- ) terminal tx ;  \ process keyboard input
  :: (S b -- ) emit ;         \ process received byte
  terminal init  \ in raw mode

  oop terminal open
\ -----------------------------------------------------------------------------
\  Last revision: MM-070224
