\ GtkComboBoxText/example.2.4th

  needs GtkToplevel
  needs GtkTable
  needs GtkLabel Array
  needs GtkAlignment Array
  needs GtkComboBoxText
  needs GtkImageFromStock
  needs GtkButton

  needs GSList

\ ------------------------------------------------------------------------------
\  csp4th :  GtkComboBox Example 2                                    MM-080311
\ ------------------------------------------------------------------------------

  gtk api definitions

  libgtk import gtk_stock_list_ids ( -- *list )


  GtkComboBoxText definitions

  private vocabulary example.2  self example.2 definitions  also gtk api

  GtkToplevel        new window
  GtkTable           new  table
  GtkLabel Array     new   labels
  GtkAlignment Array new   alignments
  GtkComboBoxText    new    combo
  GtkImage           new    image
  GtkButton          new    button

  GSList new list


  :: ( wid data -- ) 2drop gtk main_quit ;  2 20 cb cb.quit

  :: ( wid data -- )
     2drop combo @ dup if
       2dup image from-stock button-size !  button label !
     then ;  2 20 cb cb.changed

  : %label ( -- xopts yopts xpad ypad )     GTK_FILL 0  0 0 ;
  : %alignment ( -- xopts yopts xpad ypad ) GTK_FILL 0 12 0 ;

  : viewer ( -- )
 
      " GTK Stock Viewer" window init
      12 window border-width !   window resizable off
      " destroy" cb.quit 0 window signal connect drop

      table init  window add
      8 table column-spacing !  8 table row-spacing !

      3 labels init
      " Stock Item:" 0 labels of init  0 1 0 1 %label table attach
      " Image:" 1 labels of init       0 1 1 2 %label table attach
      " Button:" 2 labels of init      0 1 2 3 %label table attach
      3 0 do i labels of xalign right loop

      3 alignments init
      3 0 do i alignments of init  1 2 i dup 1+ %alignment table attach loop
      combo init  0 alignments of add
      " changed" cb.changed 0 combo signal connect drop
      " ?" image from-stock button-size init  1 alignments of add
      " ?" button init  2 alignments of add
      3 0 do i alignments of xalign left loop

      gtk_stock_list_ids list init
        list size dup 1- swap 0 do
          dup i - list of @ dup zcount combo append  free
        loop drop
        list free
      0 combo activate

      window show_all
  ;

  hide cb.quit  hide cb.changed

  previous

  viewer term? [IF] ?? [ELSE] gtk main bye [THEN]
\ ------------------------------------------------------------------------------
\ Last revision: MM-080803  show all -> show_all , gtk main -> gtk main_quit
\                MM-080525   : init -> : viewer


  
