
   needs GtkToplevel
   needs GtkVBox
   needs GtkFrame
 \ -----------------------------------------------------------------------------
 \ class GtkFrame example   for csp4th                                MM-060901
 \ -----------------------------------------------------------------------------

   GtkFrame definitions

   private vocabulary example.1  self example.1 definitions

   GtkToplevel new window
   GtkVBox     new  vbox
   GtkFrame    new   frame.0
   GtkFrame    new   frame.1
   GtkFrame    new   frame.2
   GtkFrame    new   frame.3
   GtkFrame    new   frame.4

   :: ( wid data -- ) gtk main_quit
    ; 2 20 cb cb.destroy

   : run ( -- )

      " GtkFrame example.1" window init

      6 window border-width !   260 window width-request !
                                360 window height-request !

\      1 6 vbox init window add
      vbox init window add   vbox homogeneous yes   6 vbox spacing !

      "  frame.0: shadow-type=none "       frame.0 init vbox pack_start_defaults
      "  frame.1: shadow-type=in "         frame.1 init vbox pack_start_defaults
      "  frame.2: shadow-type=out "        frame.2 init vbox pack_start_defaults
      "  frame.3: shadow-type=etched-in "  frame.3 init vbox pack_start_defaults
      "  frame.4: shadow-type=etched-out " frame.4 init vbox pack_start_defaults

      frame.0 shadow-type none
      frame.1 shadow-type in
      frame.2 shadow-type out
      frame.3 shadow-type etched-in
      frame.4 shadow-type etched-out

      " destroy" cb.destroy 0 window signal connect drop

      window show_all

   ;

   hide cb.destroy

   run term? [IF] ?? [ELSE] gtk main bye [THEN]

\ -----------------------------------------------------------------------------
\ Last Revision: MM-080803  pack defaults start -> pack_start_defaults
\                           gtk quit -> gtk main_quit , show all -> show_all
\                MM-080706  etched in -> etched-in  etched out -> etched-out
