
  needs GtkToplevel
  needs GtkHBox
  needs GtkVBox
  needs GtkEventBox Array
  needs GtkImage Array
  needs GtkImageFromStock
  needs GtkImageFromFile
  needs GtkLabel
  needs GtkTooltips
\ -----------------------------------------------------------------------------
\  GtkImage example 2 for csp4th                                     MM-070406
\ -----------------------------------------------------------------------------

  GtkImage definitions

  private vocabulary example.2  self example.2 definitions

  GtkToplevel       new window
  GtkVBox           new  vbox
  GtkHBox           new   hbox
  GtkEventBox Array new    events
  GtkImage Array    new    images
  GtkLabel          new   info

  GtkTooltips new tips

  :: ( wid 0 -- ) tips destroy gtk main_quit ; 2 20 cb cb.destroy

  : run ( -- )
 
    " GtkImage Examples Version 2" window init  6 window border-width !

    vbox init  3 vbox spacing !  window add

    hbox init  3 hbox spacing !  vbox pack_start_defaults

    7 dup events init

      dup 0 do i events of init  hbox pack_start_defaults loop

      images init

    0
    >r " gtk-dialog-info" 0 images of from-stock menu-size init
    >r " gtk-dialog-info" 1 images of from-stock small-toolbar-size init
    >r " gtk-dialog-info" 2 images of from-stock large-toolbar-size init
    >r " gtk-dialog-info" 3 images of from-stock button-size init
    >r " gtk-dialog-info" 4 images of from-stock dnd-size init
    >r " gtk-dialog-info" 5 images of from-stock dialog-size init
    >r " icons/butterfly.png" /?/ 6 images of from-file init

    begin r> ?dup 0until  events size 0 do i events of add loop

    " Place the mouse pointer over an image to see its tooltip." info init

    0 0 0 vbox pack_start

    tips init

    0 0 >r >r

    " Image 0 'dialog-info' from stock, menu-size."          >r >r
    " Image 1 'dialog-info' from stock, small-toolbar-size." >r >r
    " Image 2 'dialog-info' from stock, large-toolbar-size." >r >r 
    " Image 3 'dialog-info' from stock, button-size."        >r >r
    " Image 4 'dialog-info' from stock, dnd-size."           >r >r
    " Image 5 'dialog-info' from stock, dialog-size."        >r >r
    " Image.6 from file" " icons/butterfly.png" /?/ bl join

    begin r> r> over 0until 2drop  images size 0 do i events of wid tips ! loop

    " destroy" cb.destroy 0 window signal connect drop

    window show_all

  ;

  hide cb.destroy

  run term? [IF] ?? [ELSE] gtk main bye [THEN]
\ -----------------------------------------------------------------------------
\ Last revision: MM-080803  pack defaults start -> pack_start_defaults
\                           pack start -> pack_start
\                           gtk quit -> gtk main_quit , show all -> show_all
\                MM-080531 Reva repeat while -> begin 0until
